/*Auto Team Select
* by Sir Drink a lot
* 
*Players, who enter the server will be assigned to a team automatically
*and chooseteam is blocked.
*Use admin_autoteam 1/0 to enable or disable plugin.
*
*Admins with ACCESS_BAN will not be autoassigned!
*
*allow_client_exec 1 must be activated in adminmod.cfg
*
* version:
* 0.8.2: - found the command: jointeam. Very nice command! It should work with vgui_menu now.
*		 - the teamselect vgui_menu does not close, but it always autoassigns to team. It doesn't matter, what player has selected. :)
* 0.8.1: added connect and disconnect function to empty the User-Array
*/ 

#include <string> 
#include <admin> 
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "0.8.2";

new g_User[MAX_PLAYERS];
new g_iAutoSelect;

public plugin_init() { 
	plugin_registerinfo("Auto Team Select","All players choose auto assign on entering the server and are not able to switch teams",STRING_VERSION); 
	plugin_registercmd("admin_autoteam","admin_autoteam",ACCESS_BAN,"admin_autoteam: 1 enables automatic team select, 2 disables it.");
	plugin_registercmd("specmode","specmode",ACCESS_ALL);
	plugin_registercmd("chooseteam","chooseteam",ACCESS_ALL);
	plugin_registercmd("jointeam","jointeam",ACCESS_ALL);
	/*Automatisch NOSPEC 1 setzen, wenn vault.ini Eintrag nicht existiert!*/
	if(!get_vaultnumdata("AUTOTEAM",g_iAutoSelect)){
		set_vaultnumdata("AUTOTEAM",1);
		g_iAutoSelect=1;
	}
	return PLUGIN_CONTINUE; 
}

//After player enters the server, switch auto assign.
public specmode(HLCommand,HLData,HLUserName,UserIndex) {
	if(g_User[UserIndex]==0 && g_iAutoSelect==1 && !access(ACCESS_BAN)){
		new Player[MAX_NAME_LENGTH];
		convert_string(HLUserName,Player,MAX_NAME_LENGTH);
		execclient(Player,"jointeam 5");
		g_User[UserIndex]=1;
	}
	return PLUGIN_CONTINUE; 
}

public jointeam(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(g_iAutoSelect==1 && !access(ACCESS_BAN)){
		if(Data[0]!='5'){
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}
	
/*
public plugin_command(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Player[MAX_NAME_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,Player,MAX_NAME_LENGTH);
	snprintf(Text,MAX_TEXT_LENGTH,"Cmd: %s -- Data: %s",Command,Data);
	say(Text);
	
	return PLUGIN_CONTINUE;
}*/

//Block "chooseteam" if player has no ACCESS_BAN
public chooseteam(HLCommand,HLData,HLUserName,UserIndex) {
	if(!access(ACCESS_BAN)){
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public admin_autoteam(HLCommand,HLData,HLUserName,UserIndex) { 
	new sData[MAX_DATA_LENGTH]; 
	convert_string(HLData,sData,MAX_NAME_LENGTH); 
	if(sData[0]=='1'){ 
		set_vaultnumdata("AUTOTEAM",1);
		g_iAutoSelect=1;
		selfmessage("AUTOMATIC TEAMSELECT ACTIVATED!");
	} else{
		set_vaultnumdata("AUTOTEAM",0);
		g_iAutoSelect=0;
		selfmessage("AUTOMATIC TEAMSELECT DEACTIVATED!");
	}
	return PLUGIN_HANDLED; 
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_User[UserIndex]=0;
	return PLUGIN_CONTINUE;
}
